C*************************************************************
C     DESGN1 : DESIGN MATRIX FOR ABSOLUTE MEASUREMENTS       *
C*************************************************************
C
      SUBROUTINE DESGN1(NO,D,X,E0,NDATA,NENRG,IDX)
      INCLUDE 'param.f'
      INTEGER NO,NDATA,NENRG,IDX
      INTEGER I,J,K
      REAL*8  D(NX,NP),X(NX),E0(NP),POLYNM
C
      DO 10 I=1,NX
         DO 10 J=1,NP
   10       D(I,J)=0.0
      DO 20 I=1,NDATA
         DO 20 K=1,NENRG
   20       D(I,IDX+K)=POLYNM(X(I),E0(IDX+1),K,NO,NENRG)
      RETURN
      END
C
C*************************************************************
C     DESGN2 : DESIGN MATRIX FOR RELATIVE MEASUREMENTS       *
C*************************************************************
C
      SUBROUTINE DESGN2(NO,D,X,E0,NDATA,NE1,ID1,NE2,ID2)
      INCLUDE 'param.f'
      INTEGER NO,NDATA,NE1,NE2,ID1,ID2
      INTEGER I,J,K
      REAL*8  D(NX,NP),X(NX),E0(NP),POLYNM
C
      DO 10 I=1,NX
         DO 10 J=1,NP
            D(I,J)=0.0
   10 CONTINUE
      DO 20 I=1,NDATA
         DO 30 K=1,NE1
   30       D(I,ID1+K)= POLYNM(X(I),E0(ID1+1),K,NO,NE1)
         DO 40 K=1,NE2
   40       D(I,ID2+K)=-POLYNM(X(I),E0(ID2+1),K,NO,NE2)
   20 CONTINUE
      RETURN
      END
C
C*************************************************************
C     desgn4 : design matrix for shape measurements          *
C*************************************************************
C
      subroutine desgn4(d,ndata,idx,kp)
      include 'param.f'
      integer ndata,idx,kp
      integer i
      real*8  d(nx,np)
C
      do i=1,ndata
         d(i,idx+kp) = -1.0
      end do
      return
      end
C
C*************************************************************
C     POLYNM : SPINE BASE                                    *
C*************************************************************
C
      REAL*8 FUNCTION POLYNM(E,X,J,N,NENRG)
      INTEGER J,N,NENRG
      INTEGER L,K,ID1,ID2
      REAL*8  X(NENRG),Y,Y1,Y2,E
C
      Y=0.0
      DO 10 L=1,NENRG-1
         IF( E.GE.X(L) .AND. E.LT.X(L+1) ) GO TO 20
   10 CONTINUE
   20 ID1=L+N
      ID2=L
      IF(ID1.GT.NENRG) ID1=NENRG
      IF(ID1.LT.J .OR. ID2.GT.J) GO TO 50
      Y1=1.0
      Y2=1.0
      DO 30 K=ID2,ID1
         IF(K.EQ.J) GO TO 30
         Y1=Y1*(E   -X(K))
         Y2=Y2*(X(J)-X(K))
   30 CONTINUE
      Y=Y1/Y2
   50 POLYNM=Y
CD    WRITE(6,100) L,J,E,X(L),X(L+1),Y
  100 FORMAT(5X,'L=',I3,' I=',I3,' E=',E11.4,' X(L)=',E11.4,' X(L+1)=',
     /E11.4,' Y=',E11.4)
      RETURN
      END
