C*************************************************************
C     EXDATA : READ EXPERIMENTAL DATA                        *
C*************************************************************
C
      SUBROUTINE EXDATA(X,Y,Z,V,EMAX,EMIN,EW,cw,NDATA,NGROUP,KCOVEX)
      INCLUDE 'param.f'
C
C           KCOVEX = 1 : READ COVARIANCE FILE FROM UNIT(12)
C           KCOVEX = 0 : DONT READ COVARIANCE FILE
C
      REAL*8 X(NX),Y(NX),Z(NX),V(MX),EMAX,EMIN,EW,XX
      real*8 cw
      INTEGER NDATA,NGROUP,KCOVEX
      INTEGER I,J,L,IJ,ISTART,KG,ND,ND2,NC,IS1,IS2
      CHARACTER*43 TITLE
C
      DO 110 I=1,NX
         ISTART=I*(I-1)/2
         DO 110 J=1,I
            IJ=ISTART+J
            IF(I.EQ.J) THEN
               V(IJ)=1.0
            ELSE
               V(IJ)=0.0
            END IF
  110 CONTINUE
C***************************************
C     READ UNIT 10,11,12               *
C***************************************
      NDATA=0
      DO 210 KG=1,NGROUP
         READ(10,100) TITLE,ND
         WRITE(6,100) TITLE,ND
         IF(ND.GT.NX) THEN
            WRITE(6,2040)
            STOP
         END IF
         READ(10,300)(X(I+NDATA),Y(I+NDATA),I=1,ND)
         READ(11,100) TITLE,ND2
         IF(ND.NE.ND2) THEN
            WRITE(6,2050) ND, ND2
            STOP
         END IF
         READ(11,300)(XX        ,Z(I+NDATA),I=1,ND)
CD       WRITE(6,400)(X(I+NDATA),Y(I+NDATA),Z(I+NDATA),I=1,ND)
C
         IF(KCOVEX.EQ.1) THEN
            READ(12,100) TITLE,NC
CD          WRITE(6,100) TITLE,NC
            IF(NC.NE.0) THEN
               IF(ABS(NC).NE.ND) THEN
                  WRITE(6,2050) NC, ND
                  STOP
               END IF
               IF(NC.GE.1) THEN
                  DO 220 I=1,NC
                     ISTART=NDATA+(I+NDATA)*(I+NDATA-1)/2
                     READ(12,500)(V(ISTART+J),J=1,I)
CD                   WRITE(6,500)(V(ISTART+J),J=1,I)
  220             CONTINUE
               ELSE IF(NC.LE.-1) THEN
                  READ(12,500) XX
                  DO 230 I=1,IABS(NC)
                     ISTART=NDATA+(I+NDATA)*(I+NDATA-1)/2
                     DO 240 J=1,I-1
  240                   V(ISTART+J)=XX
                     V(ISTART+I)=1.0
CD                   WRITE(6,500)(V(ISTART+J),J=1,I)
  230             CONTINUE
               END IF
            END IF
         END IF
C
         NDATA=NDATA+ND
  210 CONTINUE
      IF(EW .EQ. 0.0) THEN
         WRITE(6,2010)
         NDATA=0
         GOTO 1000
      END IF

c....................NO 2020-11-25
c... must be commented out when compared with CRP SOK
      if (cw.gt.0.0) then
        do i=1,ndata
          y(i)=y(i)*cw
          if (z(i).lt.0.0) then
            z(i)=z(i)*cw
          endif
        enddo
      endif
c....................NO 2020-11-25
C
C***************************************
C     MAKE COVARIANCE OF EXP. DATA     *
C***************************************
      DO 310 I=1,NDATA
         IF(Z(I) .LT. 0.0) THEN
            Z(I)=EW*DABS(Z(I))/Y(I)
ca          Z(I)=EW*DABS(Z(I))
         ELSE IF(Z(I).EQ.0.0) THEN
            WRITE(6,2030) I
            NDATA=0
            GOTO 1000
         ELSE
            Z(I)=EW*Z(I)
ca          Z(I)=EW*Z(I)*Y(I)
         END IF
C        IF(Z(I)/Y(I).LE.0.03) WRITE(6,*) 'ERR < 3%, I=',I
C
         Y(I)=LOG(Y(I))

c....................NO 2020-11-25
c... must be activated when compared with CRP SOK
c        if (cw.gt.0.0) then
c          y(i)=y(i)*cw
c          if (z(i).lt.0.0) then
c            z(i)=z(i)*cw
c          endif
c        endif
c....................NO 2020-11-25

C
         ISTART=I*(I-1)/2
         DO 310 J=1,I
            IJ=ISTART+J
            IF(KCOVEX .EQ. 0) THEN
               IF(I. EQ. J) THEN
                  V(IJ)=Z(I)*Z(J)
               ELSE
                  V(IJ)=0.0
               END IF
            ELSE
               V(IJ)=V(IJ)*Z(I)*Z(J)
            END IF
  310 CONTINUE
C***************************************
C     QUICK SORT                       *
C***************************************
      DO 410 J=1,NDATA
         L=J
         DO 420 I=J,NDATA
            IF(X(I).LT.X(L)) L=I
  420    CONTINUE
         CALL SWAP(X(J),X(L))
         CALL SWAP(Y(J),Y(L))
         CALL SWAP(Z(J),Z(L))
         CALL SWCL(V,NDATA,J,L)
  410 CONTINUE
C***************************************
C     ELIMINATE OUT OF RANGE           *
C***************************************
      ND=NDATA
      DO 510 I=NDATA,1,-1
         IF(X(I) .GE. EMAX) THEN
            ND=ND-1
         ELSE IF(X(I) .LT. EMIN) THEN
            DO 520 L=I+1,NDATA
               X(L-1)=X(L)
               Y(L-1)=Y(L)
               ISTART=L*(L-1)/2
                  DO 520 J=I+1,L
                     V(ISTART+J-1)=V(ISTART+J)
  520       CONTINUE
            DO 530 L=I+1,NDATA
               IS1=(L-2)*(L-1)/2
               IS2= L   *(L-1)/2
               DO 530 J=1,L-1
                  V(IS1+J)=V(IS2+J)
  530       CONTINUE
            ND=ND-1
         END IF
  510 CONTINUE
      NDATA=ND
      IF(NDATA .EQ. 0) WRITE(6,2020)
C
CD    DO 610 I=1,NDATA
CD       ISTART=I*(I-1)/2
CD610    WRITE(6,600) X(I),Y(I),(V(ISTART+J),J=1,I)
C
  100 FORMAT(A43,I5)
  200 FORMAT(6E12.5)
  300 FORMAT(6E11.4)
  400 FORMAT(3(1PE11.4))
  500 FORMAT(12F6.3)
  600 FORMAT(6(1PE11.4))
 2010 FORMAT('*** EXP. DATA IGNORED ********')
 2020 FORMAT('*** EXP. DATA OUT OF RANGE ***')
 2030 FORMAT('*** ERR = 0 FOUND, I=',I5)
 2040 FORMAT('*** NO. OF POINTS TOO LARGE **')
 2050 FORMAT('*** NO. OF POINTS DIFFERENT **,',I5,' AND ',I5)
 1000 RETURN
      END
C
C***************************************
C     SWAP DATA A <-> B                *
C***************************************
      SUBROUTINE SWAP(A,B)
      REAL*8 A,B,C
      C=A
      A=B
      B=C
      RETURN
      END
C
C***************************************
C     SWAP COLUMNS OF COVARIANCE       *
C***************************************
      SUBROUTINE SWCL(V,N,I1,I2)
      INCLUDE 'param.f'
      REAL*8 V(MX)
      REAL*8 A(NX),B(NX),C(NX)
      INTEGER N,I1,I2
      INTEGER I,J,IJ,ISTART
C
      DO 10 J=1,N
         IF(J .LE. I1) THEN
             A(J)=V(I1*(I1-1)/2+J )
         ELSE
             A(J)=V(J *(J -1)/2+I1)
         END IF
         IF(J .LE. I2) THEN
             B(J)=V(I2*(I2-1)/2+J )
         ELSE
             B(J)=V(J *(J -1)/2+I2)
         END IF
   10 CONTINUE
      CALL SWAP(A(I1),A(I2))
      CALL SWAP(B(I1),B(I2))
C
      DO 20 I=1,N
         IF(I.NE.I1 .AND. I.NE.I2) THEN
            DO 30 J=1,N
               IF(J .LE. I) THEN
                  C(J)=V(I*(I-1)/2+J)
               ELSE
                  C(J)=V(J*(J-1)/2+I)
               END IF
   30       CONTINUE
            CALL SWAP(C(I1),C(I2))
         END IF
         ISTART=I*(I-1)/2
         DO 20 J=1,I
            IJ=ISTART+J
            IF(I .EQ. I1) THEN
               V(IJ)=B(J)
            ELSE IF(I .EQ. I2) THEN
               V(IJ)=A(J)
            ELSE
               V(IJ)=C(J)
            END IF
   20 CONTINUE
      RETURN
      END
