C*************************************************************
C     OUTSPL : WRITE RESULTS ON UNIT 15, 20, 21, 22          *
C*************************************************************
C
      SUBROUTINE OUTSPL(NPARM,NKIND,NENRG,INDEX,E0,P0,P1,PE,CX,PNAME)
      INCLUDE 'param.f'
      REAL*8 E0(NP),P0(NP),P1(NP),PE(NP),CX(MP)
      REAL*8 X0,X1,X2,X3
      INTEGER NPARM,NKIND,NENRG(NR),INDEX(NR)
      INTEGER ISTART,IKIND,I0,I,J
      CHARACTER*12 PNAME(NR)
C
      DO 10 IKIND=1,NKIND
         I0=INDEX(IKIND)
         WRITE(15,100) PNAME(IKIND),NENRG(IKIND)
         WRITE(15,200)
         DO 20 I=1,NENRG(IKIND)
            X0=EXP(P0(I0+I))
            X1=EXP(P1(I0+I))
            X2=X1*(1-PE(I0+I))
            X3=X1*(1+PE(I0+I))
            WRITE(15,300) E0(I0+I),X0,X1,X2,X3
   20    CONTINUE
         WRITE(15,400)
   10 CONTINUE
C
      DO 30 IKIND=1,NKIND
         I0=INDEX(IKIND)
         WRITE(20,100) PNAME(IKIND),NENRG(IKIND)
         WRITE(20,500)(E0(I0+I),EXP(P1(I0+I)),I=1,NENRG(IKIND))
         WRITE(21,100) PNAME(IKIND),NENRG(IKIND)
         WRITE(21,500)(E0(I0+I),PE(I0+I)     ,I=1,NENRG(IKIND))
c         DO 30 I=1,NPARM
c            ISTART=I*(I-1)/2
c            WRITE(22,600)(CX(ISTART+J),J=1,I)
   30 CONTINUE
C
  100 FORMAT('# ',A12,29X,I5)
  200 FORMAT('#   ENERGY      PRIOR     POSTERIOR ',
     &       '    -DELTA      +DELTA  ')
  300 FORMAT(5(1X,1PE11.4))
  400 FORMAT(//)
  500 FORMAT(6(1PE11.4))
  600 FORMAT(12F6.3)
      RETURN
      END
C
C*************************************************************
C     SRATIO : WRITE RATIOS OF SPLINES ON UNIT 15            *
C*************************************************************
C
      SUBROUTINE SRATIO(NO,NPARM,NKIND,NENRG,INDEX,E0,P0,P1,PE,PNAME,
     &                  NRATIO,KRATIO,D)
      INCLUDE 'param.f'
      INTEGER MR
      PARAMETER(MR=45)
      REAL*8 E0(NP),P0(NP),P1(NP),PE(NP),D(NX,NP)
      REAL*8 X0,X1,X2,X3,XE,R0,R1
      INTEGER NO,NPARM,NKIND,NENRG(NR),INDEX(NR),NRATIO,KRATIO(MR)
      INTEGER IRATIO,IR,JR,I0,J0,I,K
      CHARACTER*12 PNAME(NR)
C
      DO 10 IRATIO=1,NRATIO
C  ELIMINATE SAME KIND
         DO 20 K=1,IRATIO-1
   20       IF(KRATIO(IRATIO) .EQ. KRATIO(K)) GO TO 10
C
         IR=KRATIO(IRATIO)/100
         JR=MOD(KRATIO(IRATIO),100)
         I0=INDEX(IR)
         J0=INDEX(JR)
         CALL DESGN2(NO,D,E0(I0+1),E0,NENRG(IR),NENRG(IR),I0,
     &                                          NENRG(JR),J0)
         WRITE(15,100) PNAME(IR),PNAME(JR),NENRG(IR)
         WRITE(15,200)
         DO 30 I=1,NENRG(IR)
            R0=0.0
            R1=0.0
            DO 40 K=1,NPARM
               R0=R0+D(I,K)*P0(K)
               R1=R1+D(I,K)*P1(K)
   40       CONTINUE
            XE=SQRT(PE(I0+I)*PE(I0+I)+PE(J0+I)*PE(J0+I))
            X0=EXP(R0)
            X1=EXP(R1)
            X2=X1*(1-XE)
            X3=X1*(1+XE)
            WRITE(15,300) E0(I0+I),X0,X1,X2,X3
   30    CONTINUE
         WRITE(15,400)
   10 CONTINUE
  100 FORMAT('# ',A12,2X,A12,15X,I5)
  200 FORMAT('#   ENERGY      PRIOR     POSTERIOR ',
     &       '    -DELTA      +DELTA  ')
  300 FORMAT(5(1X,1PE11.4))
  400 FORMAT(//)
      RETURN
      END
C
C*************************************************************
C     CVRSPL : WRITE COVARIANCE MATRIX OF SPLINES ON UNIT 14 *
C*************************************************************
C
      SUBROUTINE CVRSPL(NPARM,NKIND,NENRG,INDEX,E0,P1,PE,X0,PNAME)
      INCLUDE 'param.f'
      REAL*8 E0(NP),P1(NP),PE(NP),X0(MP)
      INTEGER NPARM,NKIND,NENRG(NR),INDEX(NR),IV(NP)
      INTEGER ISTART,I,I0,J,J0,IR,JR,JMAX
      CHARACTER*12 PNAME(NR)
C
C***************************************
C     SAME REACTION                    *
C***************************************
      DO 10 IR=1,NKIND
         I0=INDEX(IR)
         WRITE(14,300) PNAME(IR)
         WRITE(14,200)(I0+J,J=1,NENRG(IR))
         DO 30 I=I0+1,I0+NENRG(IR)
            ISTART=(I*(I-1))/2
            DO 40 J=I0+1,I
               IF(PE(I).EQ.0.0 .OR. PE(J).EQ.0.0) THEN
                  IV(J-I0)=0
               ELSE
                  IV(J-I0)=X0(ISTART+J)*1000.0
               END IF
               IF(I.EQ.J) IV(J-I0)=1000
   40       CONTINUE
            JMAX=MIN(I-I0,20)
            WRITE(14,100) I,E0(I),P1(I),PE(I)*100.,(IV(J),J=1,JMAX)
            IF(JMAX .LT. I-I0) WRITE(14,200)(IV(J),J=JMAX+1,I-I0)
   30    CONTINUE
   10 CONTINUE
C
C***************************************
C     DIFFERENT REACTION               *
C***************************************
      DO 50 IR=2,NKIND
         I0=INDEX(IR)
         DO 60 JR=1,IR-1
            J0=INDEX(JR)
            WRITE(14,400) PNAME(IR),PNAME(JR)
            WRITE(14,200)(J0+J,J=1,NENRG(JR))
            DO 70 I=I0+1,I0+NENRG(IR)
               ISTART=(I*(I-1))/2
               DO 80 J=J0+1,J0+NENRG(JR)
                  IF(PE(I).EQ.0.0 .OR. PE(J).EQ.0.0) THEN
                     IV(J-J0)=0
                  ELSE
                     IV(J-J0)=X0(ISTART+J)*1000.0
                  END IF
   80          CONTINUE
               JMAX=MIN(NENRG(JR),20)
               WRITE(14,100) I,E0(I),P1(I),PE(I)*100.,(IV(J),J=1,JMAX)
               IF(JMAX .LT. NENRG(JR))
     1           WRITE(14,200) (IV(J),J=JMAX+1,NENRG(JR))
   70       CONTINUE
   60    CONTINUE
   50 CONTINUE
C 100 FORMAT(I5,3(1PE10.3),50I5)
  100 FORMAT(I5,3(1PE10.3),20I5)
C 200 FORMAT(35X,50I5)
  200 FORMAT(35X,20I5)
  300 FORMAT('DIAGONAL    ',1X,A12)
  400 FORMAT('OFF-DIAGONAL',1X,A12,/,
     &       '            ',1X,A12)
      RETURN
      END
C
C*************************************************************
C     OUTEXP : WRITE EXPERIMENTAL DATA ON UNIT > 60          *
C*************************************************************
C
      SUBROUTINE OUTEXP(X,Y,Z,NDATA,IR,IS,IM)
      INCLUDE 'param.f'
      REAL*8  X(NX),Y(NX),Z(NX)
      INTEGER NDATA,IR,IS,IM,I,KUNIT,KBASE
      DATA    KBASE/60/
C
      KUNIT=KBASE+IR
      WRITE(KUNIT,100) '#',IR,IM,IS+IM,NDATA
      DO 10 I=1,NDATA
   10    WRITE(KUNIT,200) X(I),EXP(Y(I)),Z(I)*EXP(Y(I))
      WRITE(KUNIT,300)
  100 FORMAT(1A,4I5)
  200 FORMAT(3(1PE11.4))
  300 FORMAT(//)
      RETURN
      END
