C*************************************************************
C     SPLINE : INTERPOLATION WITH SPLINE                     *
C*************************************************************
C
      SUBROUTINE SPLINE(NPARM,NKIND,NENRG,INDEX,E0,P1,PNAME)
      INCLUDE 'param.f'
      REAL*8 E0(NP),P1(NP)
      REAL*8 S(NP),H(NP),D,E,X,XINTPL
      INTEGER NPARM,NKIND,NENRG(NR),INDEX(NR)
      INTEGER IKIND,I0,I,J,JDIV
      CHARACTER*12 PNAME(NR)
      DATA JDIV/4/
C
      DO 10 IKIND=1,NKIND
         I0=INDEX(IKIND)
         CALL SUPORT(NENRG(IKIND),E0(I0+1),P1(I0+1),S,H)
         WRITE(17,100) PNAME(IKIND),(NENRG(IKIND)-1)*JDIV+1
         WRITE(17,200)
         DO 30 I=2,NENRG(IKIND)
            D = H(I)/JDIV
            DO 30 J=1,JDIV
               E = E0(I0+I-1)+D*(J-1)
               X = XINTPL(E,H(I),E0(I0+I-1),E0(I0+I),
     1                           P1(I0+I-1),P1(I0+I),
     2                           S(    I-1),S(    I))
               WRITE(17,300) E,X
   30    CONTINUE
         WRITE(17,300) E0(I0+NENRG(IKIND)),P1(I0+NENRG(IKIND))
         WRITE(17,400)
   10 CONTINUE
C
  100 FORMAT('# ',A12,29X,I5)
  200 FORMAT('#   ENERGY    POSTERIOR ')
  300 FORMAT(5(1X,1PE11.4))
  400 FORMAT(//)
      RETURN
      END
C
      SUBROUTINE SUPORT(N,X,Y,S,H)
      INCLUDE 'param.f'
      REAL*8 X(NP),Y(NP),S(NP),H(NP)
      REAL*8 A(NP),D(NP),A1(NP),B1(NP),B,C
      INTEGER N,I
C
      H(1)=0.0
      DO 10 I=2,N
   10    H(I)=X(I)-X(I-1)
C
      B=2.0
      DO 20 I=2,N-1
         A(I) = H(I+1)/(H(I)+H(I+1))
         D(I) = 3*((Y(I  )-Y(I-1))*   A(I) /H(I)  )
     &         +3*((Y(I+1)-Y(I  ))*(1-A(I))/H(I+1))
   20 CONTINUE
      A(1) = 0.0
      A(N) = 1.0
      D(1) = 3*(Y(2)-Y(1  ))/H(2)
      D(N) = 3*(Y(N)-Y(N-1))/H(N)
C
      A1(1) = B
      B1(1) = D(1)
      DO 30 I=2,N
         C     = A(I)/A1(I-1)
         A1(I) = B   - C*(1-A(I-1))
   30    B1(I) = D(I)- C*B1(I-1)
      S(N)=B1(N)/A1(N)
      DO 40 I=N-1,1,-1
   40    S(I)=(B1(I)-(1-A(I))*S(I+1))/A1(I)
C
      RETURN
      END
C
      REAL*8 FUNCTION XINTPL(E,H,X1,X2,Y1,Y2,S1,S2)
      REAL*8 E,H,X1,X2,Y1,Y2,S1,S2
      REAL*8 A,B,H2,H3
C
      A  = X2 - E
      B  = E  - X1
      H2 = H *H
      H3 = H2*H
      XINTPL = (S1*A*A*   B    - S2*B*B*   A   )/H2
     &        +(Y1*A*A*(2*B+H) + Y2*B*B*(2*A+H))/H3
      RETURN
      END
